// TestSelection2.cpp : implementation file
//

#include "stdafx.h"
#include "StsGui.h"
#include "TestSelection2.h"
#include "defs.h"
#include "externs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestSelection2 property page

IMPLEMENT_DYNCREATE(CTestSelection2, CPropertyPage)

CTestSelection2::CTestSelection2() : CPropertyPage(CTestSelection2::IDD)
{
	//{{AFX_DATA_INIT(CTestSelection2)
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDI_NIST);
}

CTestSelection2::~CTestSelection2()
{
}

void CTestSelection2::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestSelection2)
	DDX_Control(pDX, IDC_lenSequences, m_lenSequences);
	DDX_Control(pDX, IDC_numSequences, m_numSequences);
	DDX_Control(pDX, IDC_UncheckAll, m_UncheckAll);
	DDX_Control(pDX, IDC_UncheckAll_static, m_UncheckAll_static);
	DDX_Control(pDX, IDC_MAINTAB, m_CtrlTab);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTestSelection2, CPropertyPage)
	//{{AFX_MSG_MAP(CTestSelection2)
	ON_BN_CLICKED(IDC_SelectAll, OnSelectAll)
	ON_BN_CLICKED(IDC_UncheckAll, OnUncheckAll)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestSelection2 message handlers

BOOL CTestSelection2::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	char	str[32];
	
	// TODO: Add extra initialization here
	// Creating Param Tab
	m_pParamTab = new CParamTab;
	m_pParamTab->Create(CParamTab::IDD, &m_CtrlTab);
	m_CtrlTab.AddTab(m_pParamTab, "Parameterized Test Selection", 0);

	// Creating NonParam Tab
	m_pNonParamTab = new CNonParamTab;
	m_pNonParamTab->Create(CNonParamTab::IDD, &m_CtrlTab);
	m_CtrlTab.AddTab(m_pNonParamTab, "Non-parameterized Test Selection", 0);

	if ( m_pGenOptions->reuse ) {
		m_pParamTab->reuse = 1;
		if ( testVector[TESTS_ALL] || testVector[TESTS_FREQUENCY] )
			m_pNonParamTab->m_Frequency.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_BLOCK_FREQUENCY] ) {
			m_pParamTab->m_BFQCY.SetCheck(1);
			sprintf(str, "%d", tp.blockFrequencyBlockLength);
			m_pParamTab->m_BFQCY_blockLen.SetWindowText(str);
		}

		if ( testVector[TESTS_ALL] || testVector[TESTS_CUM_SUMS] )
			m_pNonParamTab->m_Cumsums.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_RUNS] )
			m_pNonParamTab->m_Runs.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_LONGEST_RUNS] )
			m_pNonParamTab->m_LongestRuns.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_RANK] )
			m_pNonParamTab->m_Rank.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_DFFT] )
			m_pNonParamTab->m_Dfft.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_NONPERIODIC_TEMPL] ) {
			m_pParamTab->m_NONP_TEMPL.SetCheck(1);
			sprintf(str, "%d", tp.nonOverlappingTemplateBlockLength);
			m_pParamTab->m_NONP_templLen.SetWindowText(str);
		}

		if ( testVector[TESTS_ALL] || testVector[TESTS_OVERLAPPING_TEMPL] ) {
			m_pParamTab->m_OverlappingTempl.SetCheck(1);
			sprintf(str, "%d", tp.overlappingTemplateBlockLength);
			m_pParamTab->m_OVERL_templLen.SetWindowText(str);
		}

		if ( testVector[TESTS_ALL] || testVector[TESTS_UNIVERSAL] ) {
			m_pParamTab->m_Universal.SetCheck(1);
			sprintf(str, "%d", tp.universalBlockLength);
			m_pParamTab->m_Universal_blockLen.SetWindowText(str);
			sprintf(str, "%d", tp.universalNumberInitializationSteps);
			m_pParamTab->m_Universal_numBlocks.SetWindowText(str);
		}

		if ( testVector[TESTS_ALL] || testVector[TESTS_APEN] ) {
			m_pParamTab->m_APEN.SetCheck(1);
			sprintf(str, "%d", tp.approximateEntropyBlockLength);
			m_pParamTab->m_APEN_blockLen.SetWindowText(str);
		}

		if ( testVector[TESTS_ALL] || testVector[TESTS_RANDOM_EXCURSIONS] )
			m_pNonParamTab->m_RandomExcr.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_RANDOM_EXCUR_VAR] )
			m_pNonParamTab->m_RandomExcrVar.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_SERIAL] ) {
			m_pParamTab->m_Serial.SetCheck(1);
			sprintf(str, "%d", tp.serialBlockLength);
			m_pParamTab->m_Serial_blockLen.SetWindowText(str);
		}

		if ( testVector[TESTS_ALL] || testVector[TESTS_LEMPEL_ZIV] )
			m_pNonParamTab->m_LempelZivCmp.SetCheck(1);

		if ( testVector[TESTS_ALL] || testVector[TESTS_LINEAR_COMPLEXITY] ) {
			m_pParamTab->m_LinearCompl.SetCheck(1);
			sprintf(str, "%d", tp.linearComplexitySequenceLength);
			m_pParamTab->m_LinearCompl_blockLen.SetWindowText(str);
		}

		m_lenSequences.EnableWindow(FALSE);
		m_numSequences.EnableWindow(FALSE);

		sprintf(str, "%d", tp.n);
		m_lenSequences.SetWindowText(str);
		sprintf(str, "%d", tp.numOfBitStreams);
		m_numSequences.SetWindowText(str);
		UpdateData(FALSE);

	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTestSelection2::OnSelectAll() 
{
	// TODO: Add your control notification handler code here
	m_pParamTab->selectAll(TRUE);
	m_pNonParamTab->selectAll(TRUE);

	// to allow user to uncheck all
	m_UncheckAll.ShowWindow(1);
	m_UncheckAll_static.ShowWindow(1);
}

LRESULT CTestSelection2::OnWizardNext() 
{
	// TODO: Add your specialized code here and/or call the base class
	char buffer[10];

	UpdateData(TRUE);

	// Checks that length and number of sequences are not <= 0
	m_lenSequences.GetLine(0, buffer, 10);
	if ( atoi(buffer) <= 0 ) {
		MessageBox("Length of sequences has to be greater than zero!", "Len Sequences Error", MB_OK|MB_ICONSTOP);
		return E_UNEXPECTED;
	}
	m_numSequences.GetLine(0, buffer, 10);
	if ( atoi(buffer) <= 0 ) {
		MessageBox("Number of sequences has to be greater than zero!", "Num Sequences Error", MB_OK|MB_ICONSTOP);
		return E_UNEXPECTED;
	}

	// lf user selects a parameterized test and did not specify any parameters
	else if ( m_pParamTab->m_APEN.GetCheck() && 
		 !m_pParamTab->m_APEN_blockLen.GetLine(0, buffer, 10) ||
		 m_pParamTab->m_BFQCY.GetCheck() &&
		 !m_pParamTab->m_BFQCY_blockLen.GetLine(0, buffer, 10)  ||
		 m_pParamTab->m_LinearCompl.GetCheck() &&
		 !m_pParamTab->m_LinearCompl_blockLen.GetLine(0, buffer, 10) ||
		 m_pParamTab->m_NONP_TEMPL.GetCheck() &&
		 !m_pParamTab->m_NONP_templLen.GetLine(0, buffer, 10) ||
		 m_pParamTab->m_OverlappingTempl.GetCheck() &&
		 !m_pParamTab->m_OVERL_templLen.GetLine(0, buffer, 10) ||
		 m_pParamTab->m_Serial.GetCheck() &&
		 !m_pParamTab->m_Serial_blockLen.GetLine(0, buffer, 10) ||
		 m_pParamTab->m_Universal.GetCheck() &&
		 (!m_pParamTab->m_Universal_blockLen.GetLine(0, buffer, 10) ||
		 !m_pParamTab->m_Universal_numBlocks.GetLine(0, buffer, 10)) ) {
		MessageBox("Missing or invalid parameters!","Warning", MB_OK|MB_ICONSTOP);
		return E_UNEXPECTED;
	}

	// lf user did not select any tests at all
	else if ( !m_pParamTab->m_APEN.GetCheck() && !m_pParamTab->m_BFQCY.GetCheck() &&
			  !m_pParamTab->m_LinearCompl.GetCheck() && !m_pParamTab->m_NONP_TEMPL.GetCheck() &&
			  !m_pParamTab->m_OverlappingTempl.GetCheck() && !m_pParamTab->m_Serial.GetCheck() &&
			  !m_pParamTab->m_Universal.GetCheck() && !m_pNonParamTab->m_Cumsums.GetCheck() &&
			  !m_pNonParamTab->m_Dfft.GetCheck() && !m_pNonParamTab->m_Frequency.GetCheck() &&
			  !m_pNonParamTab->m_LempelZivCmp.GetCheck() && !m_pNonParamTab->m_LongestRuns.GetCheck() &&
			  !m_pNonParamTab->m_RandomExcr.GetCheck() && !m_pNonParamTab->m_RandomExcrVar.GetCheck() &&
			  !m_pNonParamTab->m_Rank.GetCheck() && !m_pNonParamTab->m_Runs.GetCheck() ) {
		MessageBox("Please select at least one test.","Warning", MB_OK|MB_ICONSTOP);
		return E_UNEXPECTED;
	}

	else {
		//m_pTestConfirmation->updateListBox();
		return CPropertyPage::OnWizardNext();
	}
}

void CTestSelection2::OnUncheckAll() 
{
	// TODO: Add your control notification handler code here
	m_UncheckAll.ShowWindow(0);
	m_UncheckAll_static.ShowWindow(0);

	m_pParamTab->selectAll(FALSE);
	m_pNonParamTab->selectAll(FALSE);
}

